/*  This file is Copyright 2010 Hampton Smith
 *
 *  This file is part of Adventure! a text-adventure game engine by Hampton
 *  Smith.
 *
 *  Adventure! is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Adventure! is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Adventure!.  If not, see http://www.gnu.org/licenses/.
 */

package edu.clemson.cs.hamptos.adventure;

/**
 * <p>A <code>GameEngineException</code> is thrown by the Adventure! engine
 * when an error occurs that is the fault of the client, not the player.  It
 * indicates a bad parameter or game state.</p>
 */
public class GameEngineException extends RuntimeException {

    /**
     * <p>Creates a new <code>GameEngineException</code> with the given
     * message.</p>
     *
     * @param message The message.
     */
    public GameEngineException(String message) {
        super(message);
    }
}
